///////////////////////////////////////////////////////////////////////////////////////////////////
// Copyright 2018 Leszek Koltunski  leszek@koltunski.pl                                          //
//                                                                                               //
// This file is part of Distorted.                                                               //
//                                                                                               //
// This library is free software; you can redistribute it and/or                                 //
// modify it under the terms of the GNU Lesser General Public                                    //
// License as published by the Free Software Foundation; either                                  //
// version 2.1 of the License, or (at your option) any later version.                            //
//                                                                                               //
// This library is distributed in the hope that it will be useful,                               //
// but WITHOUT ANY WARRANTY; without even the implied warranty of                                //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU                             //
// Lesser General Public License for more details.                                               //
//                                                                                               //
// You should have received a copy of the GNU Lesser General Public                              //
// License along with this library; if not, write to the Free Software                           //
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA                //
///////////////////////////////////////////////////////////////////////////////////////////////////

precision highp float;
precision highp int;

in vec2 a_Position;           // Per-vertex position.
out vec2 v_TexCoordinate;     //
out vec2 v_Pixel;             // 2D pixel coords in window space

uniform float u_Depth;        // distance from the near plane to render plane, in clip coords
uniform vec2  u_TexCorr;      // when we blit from postprocessing buffers, the buffers can be
                              // larger than necessary (there is just one static set being
                              // reused!) so we need to compensate here by adjusting the texture
                              // coords.

uniform uvec2 u_Size;         // size of the output surface, in pixels.

//////////////////////////////////////////////////////////////////////////////////////////////

void main()
  {
  v_TexCoordinate = (a_Position + 0.5) * u_TexCorr;
  v_Pixel         = (a_Position + 0.5) * vec2(u_Size);
  gl_Position     = vec4(2.0*a_Position,u_Depth,1.0);
  }
